Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members Related Pages

# vtkCriticalSection Class Reference

`#include <vtkCriticalSection.h>`

Inheritance diagram for vtkCriticalSection:

[legend]
Collaboration diagram for vtkCriticalSection:

[legend]
List of all members.

## Detailed Description

critical section locking class

Date:
  2003/01/29 21:14:52

Revision:
  1.15

vtkCriticalSection allows the locking of variables which are accessed through different threads. This header file also defines vtkSimpleCriticalSection which is not a subclass of vtkObject. The API is identical to that of vtkMutexLock, and the behavior is identical as well, except on Windows 9x/NT platforms. The only difference on these platforms is that vtkMutexLock is more flexible, in that it works across processes as well as across threads, but also costs more, in that it evokes a 600-cycle x86 ring transition. The vtkCriticalSection provides a higher-performance equivalent (on Windows) but won't work across processes. Since it is unclear how, in vtk, an object at the vtk level can be shared across processes in the first place, one should use vtkCriticalSection unless one has a very good reason to use vtkMutexLock. If higher-performance equivalents for non-Windows platforms (Irix, SunOS, etc) are discovered, they should replace the implementations in this class

Created by:
  - Volpe, Christopher

CVS contributions (if > 5%):
  - Volpe, Christopher (72%)
  - Geveci, Berk (7%)
  - Schroeder, Will (6%)
  - Hoffman, Bill (5%)

CVS logs (CVSweb):
  - .`cxx` (`/Common/vtkCriticalSection.cxx)`
  - .`h` (`/Common/vtkCriticalSection.h)`

Definition at line 126 of file vtkCriticalSection.h.

## Public Types
typedef vtkObject | Superclass
## Public Methods
virtual const char * | GetClassName ()
virtual int | IsA (const char *type)
void | PrintSelf (ostream &os, vtkIndent indent)
void | Lock (void)
void | Unlock (void)
## Static Public Methods
vtkCriticalSection * | New ()
int | IsTypeOf (const char *type)
vtkCriticalSection * | SafeDownCast (vtkObject *o)
## Protected Methods
| vtkCriticalSection ()
## Protected Attributes
vtkSimpleCriticalSection | SimpleCriticalSection

## Member Typedef Documentation

typedef vtkObject vtkCriticalSection::Superclass

| Reimplemented from vtkObject. Definition at line 131 of file vtkCriticalSection.h.

## Constructor & Destructor Documentation

vtkCriticalSection::vtkCriticalSection | ( |  | ) | `[inline, protected]`

| Definition at line 142 of file vtkCriticalSection.h.

## Member Function Documentation

vtkCriticalSection* vtkCriticalSection::New | ( |  | ) | `[static]`

| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. Reimplemented from vtkObject.

virtual const char* vtkCriticalSection::GetClassName | ( |  | ) | `[virtual]`

| Reimplemented from vtkObject.

int vtkCriticalSection::IsTypeOf | ( | const char * | type | ) | `[static]`

| Return 1 if this class type is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkObject.

virtual int vtkCriticalSection::IsA | ( | const char * | type | ) | `[virtual]`

| Return 1 if this class is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkObject.

vtkCriticalSection* vtkCriticalSection::SafeDownCast | ( | vtkObject * | o | ) | `[static]`

| Reimplemented from vtkObject.

void vtkCriticalSection::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) | `[virtual]`

| Methods invoked by print to print information about the object including superclasses. Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes. Reimplemented from vtkObject.

void vtkCriticalSection::Lock | ( | void |  | ) | `[inline]`

| Lock the vtkCriticalSection Definition at line 149 of file vtkCriticalSection.h. References vtkSimpleCriticalSection::Lock(), and SimpleCriticalSection.

void vtkCriticalSection::Unlock | ( | void |  | ) | `[inline]`

| Unlock the vtkCriticalSection Definition at line 154 of file vtkCriticalSection.h. References SimpleCriticalSection, and vtkSimpleCriticalSection::Unlock().

## Member Data Documentation

vtkSimpleCriticalSection vtkCriticalSection::SimpleCriticalSection`[protected]`

| Definition at line 141 of file vtkCriticalSection.h. Referenced by Lock(), and Unlock().

The documentation for this class was generated from the following file:

- Common/vtkCriticalSection.h